﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;

namespace Sample
{
    public class ViewModel
    {
        public ObservableCollection<Country> Countries { get; set; }

        public ViewModel()
        {
            Countries = new ObservableCollection<Country>();
            Countries.Add(new Country() { CountryName = "India" });
            Countries.Add(new Country() { CountryName = "USA" });
            Countries.Add(new Country() { CountryName = "UK" });
            Countries.Add(new Country() { CountryName = "Germany" });
        }

    }

    public class Country : INotifyPropertyChanged
    {
        private string countryName;
        public string CountryName
        {
            get { return countryName; }
            set
            {
                if (countryName != value)
                {
                    countryName = value;
                    this.RaisedOnPropertyChanged("CountryName");
                }
            }
        }

        private ObservableCollection<League> leagues = new ObservableCollection<League>();

        public ObservableCollection<League> Leagues
        {
            get { return leagues; }
            set { leagues = value;
                this.RaisedOnPropertyChanged("Leagues");
            }
        }

        public Country()
        {
            Leagues.Add(new League() { LeagueName = "League 1" });
            Leagues.Add(new League() { LeagueName = "League 2" });
            Leagues.Add(new League() { LeagueName = "League 3" });
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

    }

    public class League : INotifyPropertyChanged
    {
        private string leagueName;
        public string LeagueName
        {
            get { return leagueName; }
            set
            {
                if (leagueName != value)
                {
                    leagueName = value;
                    this.RaisedOnPropertyChanged("LeagueName");
                }
            }
        }

        private ObservableCollection<Game> games = new ObservableCollection<Game>();

        public ObservableCollection<Game> Games
        {
            get { return games; }
            set
            {
                games = value;
                this.RaisedOnPropertyChanged("Games");
            }
        }

        public League()
        {
            Games.Add(new Game() { GameName = "Cricket" });
            Games.Add(new Game() { GameName = "Hockey" });
            Games.Add(new Game() { GameName = "VolleyBall" });
        }
        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }
    }
    public class Game: INotifyPropertyChanged
    {
        private string gameName;
        public string GameName
        {
            get { return gameName; }
            set
            {
                if (gameName != value)
                {
                    gameName = value;
                    this.RaisedOnPropertyChanged("GameName");
                }
            }
        }
       public Game()
        {

        }
        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }
    }
}
